use math
describe
label list public


twoway (scatter math homework) (lfit math homework) if schid<25500, by(schid, legend(off)) 

mixed math homework i.schtype || schid: homework, covariance(unstructured)

estat sd

predict u*, reffects reses(s*)

egen tagme = tag(schid)
egen rank = rank(u2) if tagme
serrbar u2 s2 rank if tagme, scale(1.96) ///
mvopts(mlabel(schid) msymbol(none) mlabpos(0) ///
         mlabsize(vsmall) mlabcolor(black)) ///
         title(Random Intercepts by School with 95% Prediction Intervals) ///
         xtitle(Rank) ytitle(School Effects) legend(off) yline(0)

bayes: mixed math homework i.schtype || schid: homework, covariance(unstructured)
bayes, rseed(317) melabel: ///
mixed math homework i.schtype || schid: homework, covariance(unstructured)

bayes, melabel hpd showreffects

bayesgraph diagnostics _all
bayesgraph diagnostics _all, 

bayesstats ess

search bayesparallel
bayesparallel, nproc(3): ///
bayes, rseed(317) burnin(5000) mcmcsize(15000) nchains(3): ///
mixed math homework i.schtype || schid: homework, cov(un)
bayes, melabel

bayesstats ess

bayesstats grubin


bayes, rseed(317) saving(m1): ///
mixed math homework i.schtype || schid: homework, covariance(unstructured)
estimates store m1
bayes, rseed(317) saving(m2) normalprior(5): ///
mixed math homework i.schtype || schid: homework, covariance(unstructured)
estimates store m2
bayes, rseed(317) saving(m3) iwishartprior(10): ///
mixed math homework i.schtype || schid: homework, covariance(unstructured)
estimates store m3
bayes, rseed(317) saving(m4) prior({e.math:sigma2}, jeffreys): ///
mixed math homework i.schtype || schid: homework, covariance(unstructured)
estimates store m4

bayesstats ic m*, diconly

estimates restore m1
bayesstats summary (corr:{U:Sigma_2_1}/sqrt({U:Sigma_1_1}*{U:Sigma_2_2}))

bayestest interval {math:1.schtype}, upper(0)

bayesmh math homework i.schtype U0[schid] U1[schid]#c.homework, ///
likelihood(normal({e.math:sigma2})) ///
prior({math:},         normal(0,10000)) ///
prior({e.math:sigma2}, igamma(0.01,0.01)) ///
prior({U0 U1},         mvnormal(2,0,0,{Sigma,matrix})) ///
prior({Sigma,m},       iwishart(2,3,I(2)))

bayesmh math homework i.schtype U0[schid] U1[schid]#c.homework, ///
likelihood(normal({e.math:sigma2})) ///
prior({math:},         normal(0,10000)) ///
prior({e.math:sigma2}, igamma(0.01,0.01)) ///
prior({U0 U1},         mvn0identity(2,{Sigma})) ///
prior({Sigma},         igamma(0.01,0.01))

bayesmh math homework i.schtype U0[schid] U1[schid]#c.homework, ///
likelihood(normal({e.math:sigma2})) ///
prior({math:},         normal(0,10000)) ///
prior({e.math:sigma2}, igamma(0.01,0.01)) 

bayesmh math homework i.schtype U0[schid] U1[schid]#c.homework, 
likelihood(normal({e.math:sigma2})) 
prior({math:},         normal(0,10000)) 
prior({e.math:sigma2}, igamma(0.01,0.01)) 
prior({U0 U1},         mvn0exchangeable(2,{Sigma},{rho})) 
prior({Sigma},         igamma(0.01,0.01)) 
prior({rho},           uniform(-1,1)

bayesmh math homework i.schtype U0[schid] U1[schid]#c.homework, ///
likelihood(normal({e.math:sigma2})) ///
prior({math:},         normal(0,10000)) ///
prior({e.math:sigma2}, igamma(0.01,0.01)) ///
prior({U0 U1},         mvn0(2,{Sigma,m})) ///
prior({Sigma,m},       iwishart(2,3,I(2)))

bayesmh math homework i.schtype U0[schid] U1[schid]#c.homework, ///
likelihood(normal({e.math:sigma2})) ///
prior({math:},         normal(0,10000)) ///
prior({e.math:sigma2}, igamma(0.01,0.01)) ///
prior({U0 U1},         mvn0(2,{Sigma,m})) ///
prior({Sigma,m},       iwishart(2,3,I(2)))

bayesmh math homework i.schtype U0[schid] U1[schid]#c.homework, ///
likelihood(normal({e.math:sigma2})) ///
prior({math:}, normal(0,10000)) ///
prior({e.math:sigma2}, igamma(0.01,0.01)) ///
prior({U0 U1},         t(0,{Sigma},{df}),split) ///
prior({Sigma},         igamma(0.01,0.01)) ///
prior({df},            uniform(1,500))

bayesmh math homework i.schtype U0[schid] U1[schid]#c.homework, ///
likelihood(normal({e.math:sigma2})) ///
prior({math:}, normal(0,10000)) ///
prior({e.math:sigma2}, igamma(0.01,0.01)) ///
prior({U0 U1}, mvnormal(2,0,0,{Sigma,matrix})) ///
prior({Sigma,m}, iwishart(2,3,I(2))) ///
block({math:}, gibbs) ///
block({U0 U1} {e.math:sigma2} {Sigma,m}, split gibbs) ///
rseed(317)

bayesgraph diagnostics {math:homework}

bayesstats ess

bayesmh, showreffects
bayesstats summary {U0}

svmat r(summary), names(u2b_)

twoway (kdensity u2 if tagme) (kdensity u2b_1),  ///
legend(order(1 "BLUP" 2 "Full Bayesian"))


egen rankb = rank(u2b_1), unique
serrbar u2b_1 u2b_2 rankb, scale(1.96) ///
title() xtitle(Rank) ytitle(School effects) legend(off) yline(0)

bayesmh, saving(bmh)
bayespredict {_ysim}, saving(prdata)
bayesstats ppvalues (@max({_resid})) using prdata
